/*
 *	main.c
 *
 *	pfXǂ
 *
 *	* Sat Aug 21 11:47:00 JST 2004 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	int retval;
	int i;

	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		retval = demo_main();
		if(retval < 0) break;
		memset(vbuff, 3, sizeof vbuff);
		for(i = 0; i < SEC(0.25); i++) schedule();
		switch(retval) {
		case 0:
			game_main();
			break;
		case 1:
			yaku_main();
			break;
		default:
			DIE();
		}
		memset(vbuff, 3, sizeof vbuff);
		for(i = 0; i < SEC(0.25); i++) schedule();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/

	/* wiC[WWJB */
	sprite_draw(0, 0, SPR_BG, 0);
	memcpy(bgbuff, vbuff, DISP_X * DISP_Y);

	/* nCXRAB */
	hiscore = 1000;

/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
//#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x5f0		/* PAUSEJ[(16KEwip) */
//#define PAUSE_COLOR	0xa0f		/* PAUSEJ[(16KEwip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	int result = -1;
	int x;
	int y;
	int sprno;

	pcePadSetTrigMode(PP_MODE_REPEAT);
	for(;;) {
		schedule();
		memset(vbuff, 2, sizeof vbuff);

		/* ^Cg\B */
		x = 12;
		y = 24;
		if(now & 2) {
			sprno = SPR_TITLE1;
		} else {
			sprno = SPR_TITLE0;
		}
		sprite_draw(x, y, sprno, 0);
		x += 16;
		y += 27;
		render_string_framed(&render, x, y, "ǂ", 0x80, 0x231);

		/* X^[gHHIH */
		if(joy & TRG_A) {
			result = 0;
			break;
		}
		if(joy & TRG_B) {
			result = 1;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}

		/* ՓxIB */
		if((joy & TRG_LF) && (level_sel > 0)) {
			level_sel--;
		}
		if((joy & TRG_RI) && (level_sel < 9)) {
			level_sel++;
		}

		/* XRA\B */
		x = 1;
		y = 1;
		render_string_framed(&render, x, y, "1UP  ", 0x82, 0x231);
		y += 8;
		render_printf_framed(&render, x, y, 0x82, 0x230, "%5d", game.score <= 99999 ? game.score : 99999);

		x = DISP_X - 22;
		y = 1;
		render_string_framed(&render, x, y, "HIGH ", 0x82, 0x231);
		y += 8;
		render_printf_framed(&render, x, y, 0x82, 0x230, "%5d", hiscore <= 99999 ? hiscore : 99999);

		/* vvg\B */
		x = (DISP_X - 4 * 8) / 2;
		y = DISP_Y - 48;
		render_string_framed(&render, x, y, " A START", 0x82, 0x230);
		y += 8;
		render_string_framed(&render, x, y, " B  YAKU", 0x82, 0x230);
		y += 8;
		render_string_framed(&render, x, y, "SEL EXIT", 0x82, 0x230);

		/* xI\B */
		x = (DISP_X - 4 * 10) / 2;
		y = DISP_Y - 12;
		if(level_sel == 0) {
			render_printf_framed(&render, x, y, 0x82, 0x230, "  LEVEL%2d >", level_sel + 1);
		} else if(level_sel == 9) {			       
			render_printf_framed(&render, x, y, 0x82, 0x230, "< LEVEL%2d  ", level_sel + 1);
		} else {
			render_printf_framed(&render, x, y, 0x82, 0x230, "< LEVEL%2d >", level_sel + 1);
		}
	}
	pcePadSetTrigMode(PP_MODE_SINGLE);

	return result;
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	memset(&game, 0, sizeof game);

	/* V[hB */
	game.seed = now;

	/* xݒB */
	game.line = level_sel * LEVEL_LINE;

	/* _CXIB */
	game.player_dice = 1;
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	int i;
	int x;
	int y;

	game_init();

	for(;;) {
		player_action();
		if(game.player_stat != PST_LINE) {
			if(field_action()) {
				break;
			}
		}
		field_disp();
		schedule();
	}

	game.player_stat = PST_GAMEOVER;
	game.player_cnt = 0;
	game.shot_dice = 0; /* VbgLZ */
	game.hit_stat = 0;  /* qbg}[NLZ */
	for(i = 0; i < SEC(10); i++) {
		if((joy & TRG_AB) && (i >= SEC(3))) {
			break;
		}
		player_action();
		field_disp();
		if(i >= SEC(2)) {
			memset(game.field, 0, sizeof game.field);
			x = FIELD_X + (CELL_W * FIELD_COLS - 4 * 9) / 2;
			y = FIELD_Y + (CELL_H * FIELD_ROWS - 6    ) / 2;
			render_string_framed(&render, x, y, "GAME OVER", 0x82, 0x203);
		}
		schedule();
	}
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp()
{
	int x;
	int y;
	int col;
	int row;
	int dice;
	int sprno;

	/* wi\B */
	memcpy(vbuff, bgbuff, DISP_X * DISP_Y);

	/* ubN\B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			dice = game.field[row][col];
			if(dice) {
				x = FIELD_X + CELL_W * col;
				y = FIELD_Y + CELL_H * row;
				sprno = SPR_DICE01 + (dice - 1);
				sprite_draw(x, y, sprno, 0);
			}
		}
	}

	/* Vbg\B */
	if(game.shot_dice) {
		x = FIELD_X + CELL_W * game.shot_col;
		y = FIELD_Y + CELL_H * game.shot_row;
		sprno = SPR_DICE01 + (game.shot_dice - 1);
		sprite_draw(x, y, sprno, 0);
	}

	/* qbg}[N\B */
	if(game.hit_stat) {
		x = FIELD_X + CELL_W * game.hit_col;
		y = FIELD_Y + CELL_H * game.hit_row;
		sprno = SPR_HIT0 + game.hit_cnt / 2/**/;
		sprite_draw(x, y, sprno, 0);
	}

	/* _CXIEvC[\B */
	x = FIELD_X + CELL_W * game.player_col;
	y = FIELD_Y + CELL_H * FIELD_ROWS - 3/**/;
	switch(game.player_stat) {
	case 0: /* ʏ */
		sprno = SPR_PNORM;
		break;
	case PST_LEFT: /* ړ */
		x += (CELL_W - game.player_cnt);
		if(game.player_cnt < CELL_W / 2) {
			sprno = SPR_PMVLF0;
		} else {
			sprno = SPR_PMVLF1;
		}
		break;
	case PST_RIGHT: /* Eړ */
		x -= (CELL_W - game.player_cnt);
		if(game.player_cnt < CELL_W / 2) {
			sprno = SPR_PMVRI0;
		} else {
			sprno = SPR_PMVRI1;
		}
		break;
	case PST_SHOT: /* Vbg */
		sprno = SPR_PSHOT;
		break;
	case PST_LINE: /* C */
		switch((game.player_cnt / 4/**/) & 3) {
		case 0:  sprno = SPR_PLINE0; break;
		case 2:  sprno = SPR_PLINE2; break;
		default: sprno = SPR_PLINE1; break;
		}
		break;
	case PST_GAMEOVER: /* Q[I[o[ */
		if(game.player_cnt < SEC(0.35)) {
			sprno = SPR_POVER0;
		} else {
			sprno = SPR_POVER1;
		}
		break;
	default:
		DIE();
	}
	sprite_draw(
		x,
		FIELD_Y + CELL_H * (FIELD_ROWS - 1),
		SPR_DICE01 + (game.player_dice - 1),
		0);
	sprite_draw(x, y, sprno, 0);

	/* XgbNEŃC\B */
	if(game.player_stat == PST_LINE) {
		x = FIELD_X;
		y = FIELD_Y + CELL_H * (FIELD_ROWS + 1);
		sprno = SPR_DICEL;
		sprite_draw(x, y, sprno, 0);
		render_font(&render, x + 3, y + 2, '0' + game.line_num, 0x82, 0);
		render_font(&render, x + 4, y + 2, '0' + game.line_num, 0x82, 0);
		x += CELL_W;
		sprite_draw(x, y, sprno, 0);
		render_font(&render, x + 3, y + 2, 'L', 0x82, 0);
		render_font(&render, x + 4, y + 2, 'L', 0x82, 0);
		x += CELL_W;
		sprite_draw(x, y, sprno, 0);
		render_font(&render, x + 3, y + 2, 'I', 0x82, 0);
		render_font(&render, x + 4, y + 2, 'I', 0x82, 0);
		x += CELL_W;
		sprite_draw(x, y, sprno, 0);
		render_font(&render, x + 3, y + 2, 'N', 0x82, 0);
		render_font(&render, x + 4, y + 2, 'N', 0x82, 0);
		x += CELL_W;
		sprite_draw(x, y, sprno, 0);
		render_font(&render, x + 3, y + 2, 'E', 0x82, 0);
		render_font(&render, x + 4, y + 2, 'E', 0x82, 0);
	} else {
		for(col = 0; col < FIELD_COLS; col++) {
			dice = game.stock[col];
			if(dice) {
				x = FIELD_X + CELL_W * col;
				y = FIELD_Y + CELL_H * (FIELD_ROWS + 1);
				if(game.line_num && FLASH) {
					sprno = SPR_DICE11;
				} else {
					sprno = SPR_DICE01;
				}
				sprno += (dice - 1);
				sprite_draw(x, y, sprno, 0);
			}
		}
		if(game.line_num) {
			x = DISP_X - 1;
			y = DISP_Y;
			if(FLASH) {
				sprno = SPR_LDOWN0;
			} else {
				sprno = SPR_LDOWN1;
			}
			sprite_draw(x, y, sprno, 0);
			x -= 11;
			y -= 12;
			render_font(&render, x    , y, '0' + game.line_num, 0x82, 3);
			render_font(&render, x + 1, y, '0' + game.line_num, 0x82, 3);
		}
	}

	/* XRAExB */
	x = 67;
	y = 3;
	render_printf_framed(&render, x  , y, 0x82, 0x230, "HIGH");
	y += 6;
	render_printf_framed(&render, x-4, y, 0x82, 0x230, "%6d", hiscore <= 999999 ? hiscore : 999999);
	y += 12;
	render_printf_framed(&render, x  , y, 0x82, 0x230, "1UP");
	y += 6;
	render_printf_framed(&render, x-4, y, 0x82, 0x230, "%6d", game.score <= 999999 ? game.score : 999999);
	y += 12;
	render_printf_framed(&render, x  , y, 0x82, 0x230, "LINE");
	y += 6;
	render_printf_framed(&render, x  , y, 0x82, 0x230, "%5d", LEVEL_LINE - game.line % LEVEL_LINE);
	y += 12;
	render_printf_framed(&render, x  , y, 0x82, 0x230, "LEVEL");
	y += 6;
	render_printf_framed(&render, x  , y, 0x82, 0x230, "%5d",          1 + game.line / LEVEL_LINE);
}

/****************************************************************************
 *	field_empty
 ****************************************************************************/

int
field_empty()
{
	int col;
	int row;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			if(game.field[row][col]) return 0;
		}
	}

	return 1;
}

/****************************************************************************
 *	field_action
 ****************************************************************************/

int
field_action()
{
	int result = 0;
	//
	int col;
	int row;
	int delay;

	game.down_cnt--;
	if(joy & TRG_SELECT) {
		for(col = 0; col < FIELD_COLS; col++) {
			if(game.field[FIELD_ROWS - 2][col]) break;
		}
		if(col == FIELD_COLS) {
			game.down_cnt = 0;
		}
	}

	delay = down_delay();
	while(game.down_cnt <= 0) {
		game.down_cnt += delay;
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			for(row = FIELD_ROWS - 1; row > 0; row--) {
				game.field[row][col] = game.field[row - 1][col];
			}
			game.field[0][col] = RND16_RANGE(game.seed, 1, 6+1);
			if(game.field[FIELD_ROWS - 1][col]) {
				result = 1;
			}
		}
	}

	return result;
}

/****************************************************************************
 *	player_action
 ****************************************************************************/

void
player_action()
{
	/* ړB */
	if((joy & PAD_LF) && (game.player_col > 0)) {
		switch(game.player_stat) {
		case 0:
		case PST_SHOT: /* [VLZ */
			game.player_stat = PST_LEFT;
			game.player_cnt = 0;
			game.player_col--;
			break;
		case PST_RIGHT: /* ړ] */
			game.player_stat = PST_LEFT;
			game.player_cnt = CELL_W - game.player_cnt;
			game.player_col--;
			break;
		}
	}
	if(game.player_stat == PST_LEFT) {
		game.player_cnt += PLAYER_SPEED;
		while(game.player_cnt >= CELL_W) {
			if((joy & PAD_LF) && (game.player_col > 0)) {
				game.player_cnt -= CELL_W;
				game.player_col--;
			} else {
				game.player_stat = 0;
				game.player_cnt = 0;
			}
		}
	}

	/* EړB */
	if((joy & PAD_RI) && (game.player_col < FIELD_COLS - 1)) {
		switch(game.player_stat) {
		case 0:
		case PST_SHOT: /* [VLZ */
			game.player_stat = PST_RIGHT;
			game.player_cnt = 0;
			game.player_col++;
			break;
		case PST_LEFT: /* ړ] */
			game.player_stat = PST_RIGHT;
			game.player_cnt = CELL_W - game.player_cnt;
			game.player_col++;
			break;
		}
	}
	if(game.player_stat == PST_RIGHT) {
		game.player_cnt += PLAYER_SPEED;
		while(game.player_cnt >= CELL_W) {
			if((joy & PAD_RI) && (game.player_col < FIELD_COLS - 1)) {
				game.player_cnt -= CELL_W;
				game.player_col++;
			} else {
				game.player_stat = 0;
				game.player_cnt = 0;
			}
		}
	}

	/* _CXIB */
	if(joy & TRG_B) {
		switch(game.player_stat) {
		case 0:
		case PST_LEFT:
		case PST_RIGHT:
		case PST_SHOT:
		case PST_LINE:
			if(game.player_dice == 6) {
				game.player_dice = 1;
			} else {
				game.player_dice++;
			}
			break;
		}
	}

	/* qbg}[NB */
	if(game.hit_stat) {
		game.hit_cnt++;
		if(game.hit_cnt >= 5 * 2/**/) {
			game.hit_stat = 0;
			game.hit_cnt = 0;
		}
	}

	/* VbgB */
	if(game.player_stat == PST_SHOT) {
		game.player_cnt++;
		if(game.player_cnt >= SEC(0.25)) {
			game.player_stat = 0;
			game.player_cnt = 0;
		}
	}
	if(joy & TRG_A) {
		switch(game.player_stat) {
		case 0:
		case PST_SHOT: /* [VLZ */
			game.player_stat = PST_SHOT;
			game.player_cnt = 0;
			/* FALL THRU */
		case PST_LEFT: /* [VLZ */
		case PST_RIGHT: /* [VLZ */
			if(game.shot_dice) { /* [VLZ */
				game.shot_row = 0;
				shot_action();
			}
			game.shot_dice = game.player_dice;
			game.shot_col = game.player_col;
			game.shot_row = FIELD_ROWS - 1; /* shot_action()ĂԂ̂ŁAoʒuFIELD_ROWS-2(=_CXI\̈)ɂȂ܂ */
			break;
		}
	}
	shot_action();

	/* CŁB */
	if(game.player_stat == PST_LINE) {
		game.player_cnt++;
		if(!(game.player_cnt % 4/**/) &&
		   ((game.player_cnt / 4/**/) != 1) &&
		   ((game.player_cnt / 4/**/) & 1)) {
			game.line_cnt++;
			if(line_erase()) {
				score_add(FIELD_COLS * game.line_cnt);
			}
		} else {
			if(field_empty() || (game.line_cnt == game.line_num)) {
				game.player_stat = 0;
				game.player_cnt = 0;
				if(game.down_cnt < SEC(1)) {
					game.down_cnt = SEC(1);
				}
			}
		}
	}
	switch(game.player_stat) {
	case 0:
	case PST_LEFT:
	case PST_RIGHT:
	case PST_SHOT:
		line_test();
		break;
	}
	if((joy & TRG_DN) && (game.line_num)) {
		switch(game.player_stat) {
		case 0:
		case PST_LEFT: /* [VLZ */
		case PST_RIGHT: /* [VLZ */
		case PST_SHOT: /* [VLZ */
			game.player_stat = PST_LINE;
			game.player_cnt = 0;
			game.line_cnt = 0;
			memset(game.stock, 0, sizeof game.stock);
			break;
		}
	}

	/* Q[I[o[B */
	if(game.player_stat == PST_GAMEOVER) {
		game.player_cnt++;
	}
}

/****************************************************************************
 *	shot_action
 ****************************************************************************/

void
shot_action()
{
	int i;
	int col;
	int row;
	int dice;

	if(!game.shot_dice) return;

	/* VbgړB */
	game.shot_row--;

	col = game.shot_col;
	for(row = FIELD_ROWS - 1; row >= game.shot_row; row--) {
		if(row < 0) break; /* Kv!! */

		dice = game.field[row][col];
		if(dice) {
			if(dice == game.shot_dice) {
				/* ubNŁB */
				game.field[row][col] = 0;
				score_add(1);
				/* qbg}[NoB */
				game.hit_stat = 1;
				game.hit_cnt = 0;
				game.hit_col = col;
				game.hit_row = row;
				/* XgbNɒǉB */
				for(i = 0; i < FIELD_COLS - 1; i++) {
					game.stock[i] = game.stock[i + 1];
				}
				game.stock[FIELD_COLS - 1] = dice;
			}
			/* VbgŁB */
			game.shot_dice = 0;
			return;
		}
	}

	if(game.shot_row < 0) {
		/* VbgŁB */
		game.shot_dice = 0;
	}
}

/****************************************************************************
 *	line_test
 ****************************************************************************/

void
line_test()
{
	int i;
	int num = 0;
	int sum = 0;

	/* ]ځEځE21 */
	for(i = 0; i <= FIELD_COLS - 3; i++) {
		if(game.stock[i]) {
			if(game.stock[i + 0]     == game.stock[i + 1] &&
			   game.stock[i + 1]     == game.stock[i + 2]) num++;
			if(game.stock[i + 0] + 1 == game.stock[i + 1] &&
			   game.stock[i + 1] + 1 == game.stock[i + 2]) num++;
		}
		sum += game.stock[i];
	}
	for(/** no job **/; i < FIELD_COLS; i++) {
		sum += game.stock[i];
	}
	if(sum == 21) num++;

	/* jRjR */
	if(game.stock[0]) {
		/* NOTE: "112211"łOKłB */
		if(game.stock[0] == game.stock[1] &&
		   game.stock[1] != game.stock[2] &&
		   game.stock[2] == game.stock[3] &&
		   game.stock[3] != game.stock[4] &&
		   game.stock[4] == game.stock[5]) num += 3;
	}

	game.line_num = num;
}

/****************************************************************************
 *	line_erase
 ****************************************************************************/

int
line_erase()
{
	int col;
	int row;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			if(game.field[row][col]) {
				do {
					game.field[row][col] = 0;
					col--;
				} while(col >= 0);
				game.line++; /* g[^ŃCJEgAbv */
				return 1;
			}
		}
	}

	return 0;
}

/****************************************************************************
 *	score_add
 ****************************************************************************/

void
score_add(int pts)
{
	game.score += pts;
	if(game.score > hiscore) {
		hiscore = game.score;
	}
}

/****************************************************************************
 *	down_delay
 ****************************************************************************/

int
down_delay()
{
	int delay;

	delay  = SEC(7);
	delay -= SEC(0.50) * (game.line / LEVEL_LINE);
	delay -= SEC(0.75) * (game.line % LEVEL_LINE) / LEVEL_LINE;
	if(delay < SEC(0.5)) delay = SEC(0.5);

	return delay;
}

/****************************************************************************
 *	yaku_main
 ****************************************************************************/

typedef struct _YAKU {
	const char* str[3];
	int dice[2][6 + 1];
} YAKU;
static const YAKU yaku_list[5] = {
	{ { "]"  , "Rȏ㓯", "1-4LINE" }, { {6,6,6,0,0,0, 1}, {1,1,1,1,1,1, 4} } },
	{ { ""  , "Rȏ㑱", "1-4LINE" }, { {1,2,3,0,0,0, 1}, {2,3,4,5,6,0, 3} } },
	{ { "QP"    , "SłQP"    , "  1LINE" }, { {6,3,6,6,0,0, 1}, {5,6,3,5,1,1, 1} } },
	{ { "jRjR", "Q~Rg"    , "  3LINE" }, { {6,6,1,1,4,4, 3}, {3,3,1,1,3,3, 3} } },
	{ { "g"  , NULL            , NULL      }, { {1,1,1,6,6,6, 3}, {1,2,3,4,5,6, 5} } },
};
static const int winning_structures[10][6 + 1] = {
	{ 1,2,3,4,5,6, 5 },
	{ 3,3,3,3,3,3, 4 },
	{ 6,6,1,1,2,2, 3 },
	{ 5,5,5,5,5,0, 3 },
	{ 2,3,4,5,6,0, 3 },
	{ 4,4,4,4,0,0, 2 },
	{ 2,3,4,5,0,0, 2 },
	{ 6,6,3,6,0,0, 1 },
	{ 1,1,1,0,0,0, 1 },
	{ 4,5,6,0,0,0, 1 },
};

void
yaku_main()
{
	int sel = 0;
	int i;
	int j;
	int x;
	int y;
	int dice;
	int sprno;
	const YAKU* yaku;
	const char* str;

	for(;;) {
		schedule();
		memset(vbuff, 3, sizeof vbuff);

		if(joy & TRG_B) break;
		if((joy & TRG_LF) && (sel > 0)) sel--;
		if((joy & TRG_RI) && (sel < 5)) sel++;

		if(sel < 5) {
			yaku = &yaku_list[sel];
			str = "̐";
			x = (DISP_X - 5 * strlen(str)) / 2;
			y = 2;
			render_string_framed(&render, x, y, str, 0x80, 0x203);
			y += 23;
			x = 2;
			render_printf(&render, x, y, 0x80, 0, "%d.%s", sel + 1, yaku->str[0]);
			y += 12;
			if(yaku->str[1]) {
				render_printf(&render, x, y, 0x80, 0, " (%s)", yaku->str[1]);
			}
			y += 12;
			x = DISP_X - (4 * strlen(yaku->str[2]) + 3);
			if(yaku->str[2]) {
				render_printf(&render, x, y, 0x82, 0, "%s", yaku->str[2]);
			}
			y += 17;
			for(i = 0; i < 2; i++) {
				x = 4;
				for(j = 0; j < 6; j++) {
					dice = yaku->dice[i][j];
					if(dice) {
						sprno = SPR_DICE01 + (dice - 1);
						sprite_draw(x, y, sprno, 0);
					} else {
						render_point(&render, x + 2, y + 8, 0);
						render_point(&render, x + 7, y + 8, 0);
					}
					x += CELL_W;
				}
				x += 1;
				render_printf(&render, x, y + 4, 0x82, 0, "%dLINE", yaku->dice[i][j]);
				y += CELL_H + 2;
			}

		} else {
			str = "WINNING STRUCTURES";
			x = (DISP_X - 4 * strlen(str)) / 2;
			y = 2;
			render_string_framed(&render, x, y, str, 0x82, 0x203);
			y += 9;
			for(i = 0; i < 10; i++) {
				x = 4;
				for(j = 0; j < 6; j++) {
					dice = winning_structures[i][j];
					if(dice) {
						sprno = SPR_DICE01 + (dice - 1);
						sprite_draw(x, y, sprno, 0);
					} else {
						render_point(&render, x + 2, y + 8, 0);
						render_point(&render, x + 7, y + 8, 0);
					}
					x += CELL_W;
				}
				x += 1;
				render_printf(&render, x, y + 4, 0x82, 0, "%dLINE", winning_structures[i][j]);
				y += CELL_H + 1;
			}
		}

		if(now % SEC(1) < SEC(0.75)) {
			y = DISP_Y - 7;
			if(sel > 0) {
				x = 2;
				render_string(&render, x, y, "<PREV", 0x82, 0);
			}
			x = (DISP_X - 4 * 6) / 2;
			render_string(&render, x, y, "B:BACK", 0x82, 0);
			if(sel < 5) {
				x = DISP_X - 4 * 5;
				render_string(&render, x, y, "NEXT>", 0x82, 0);
			}
		}
	}
}
